----------------------------------------------------------------
-- Euclidean Algorithm (Euclidean_algorithm_Polynomials.adb)
--
-- 
--
----------------------------------------------------------------
with Gnat.Io; use Gnat.Io;
with Polynomials; use Polynomials;
procedure Euclidean_Algorithm_Polynomials is
   F, G, H, A, B, C, D, Q, R, Next_D, Z, Y, Zero: Polynomial;
begin
   for I in 0 .. M loop G(I) := 0; H(I) := 0; F(I) := 0; end loop;
   
   --F(0) := 237; F(17) := 1;
   F(0) := 237; F(7) := 29; F(14) := 42; F(17) := 1;
   G(1) := 1; G(5) := 47; G(9) := 230; G(15) := 117;
   H(3) := 211; H(9) := 123; H(11) := 7; H(15) := 189;
   for I in 0 .. M loop Zero(I) := 0; end loop; 
   ----------------------------------------------------------------------------
   A := F; B := H; C := Zero; D := G;
   while Degree(B) > 0 loop
      Q := Quotient(A, B); R := Remainder(A, B); 
      Next_D := Subtract(C, Product_Mod_F(D, Q, F));
      A := B; B := R; C := D; D := Next_D;
   end loop;
   Z := Product(D, Invert(B(0)));
   -----------------------------------------------------------------------------
   Y := Product_Mod_F(Z, H, F);
   Put("g = "); for I in 0 .. M-1 loop Put(G(I)); Put("  "); end loop; New_Line;
   Put("h = "); for I in 0 .. M-1 loop Put(H(I)); Put("  "); end loop; New_Line;
   Put("z = "); for I in 0 .. M-1 loop Put(Z(I)); Put("  "); end loop; New_Line;
   Put("z.h = "); for I in 0 .. M-1 loop Put(Y(I)); Put("  "); end loop; New_Line;
end Euclidean_Algorithm_Polynomials;